## Matrix Stacks

Matrix Stacks — Functions for efficiently tracking many related transformations

## Functions

CoglMatrixStack * | cogl_matrix_stack_new ()
void | cogl_matrix_stack_push ()
void | cogl_matrix_stack_pop ()
void | cogl_matrix_stack_load_identity ()
void | cogl_matrix_stack_scale ()
void | cogl_matrix_stack_translate ()
void | cogl_matrix_stack_rotate ()
void | cogl_matrix_stack_rotate_quaternion ()
void | cogl_matrix_stack_rotate_euler ()
void | cogl_matrix_stack_multiply ()
void | cogl_matrix_stack_frustum ()
void | cogl_matrix_stack_perspective ()
void | cogl_matrix_stack_orthographic ()
CoglBool | cogl_matrix_stack_get_inverse ()
CoglMatrixEntry * | cogl_matrix_stack_get_entry ()
CoglMatrix * | cogl_matrix_stack_get ()
CoglMatrix * | cogl_matrix_entry_get ()
void | cogl_matrix_stack_set ()
CoglBool | cogl_matrix_entry_calculate_translation ()
CoglBool | cogl_matrix_entry_is_identity ()
CoglBool | cogl_matrix_entry_equal ()
CoglMatrixEntry * | cogl_matrix_entry_ref ()
void | cogl_matrix_entry_unref ()

## Types and Values

| CoglMatrixStack
| CoglMatrixEntry

## Description

Matrices can be used (for example) to describe the model-view transforms of objects, texture transforms, and projective transforms.

The CoglMatrix api provides a good way to manipulate individual matrices representing a single transformation but if you need to track many-many such transformations for many objects that are organized in a scenegraph for example then using a separate CoglMatrix for each object may not be the most efficient way.

A CoglMatrixStack enables applications to track lots of transformations that are related to each other in some kind of hierarchy. In a scenegraph for example if you want to know how to transform a particular node then you usually have to walk up through the ancestors and accumulate their transforms before finally applying the transform of the node itself. In this model things are grouped together spatially according to their ancestry and all siblings with the same parent share the same initial transformation. The CoglMatrixStack API is suited to tracking lots of transformations that fit this kind of model.

Compared to using the CoglMatrix api directly to track many related transforms, these can be some advantages to using a CoglMatrixStack:

- Faster equality comparisons of transformations
- Efficient comparisons of the differences between arbitrary transformations
- Avoid redundant arithmetic related to common transforms
- Can be more space efficient (not always though)

For reference (to give an idea of when a CoglMatrixStack can provide a space saving) a CoglMatrix can be expected to take 72 bytes whereas a single CoglMatrixEntry in a CoglMatrixStack is currently around 32 bytes on a 32bit CPU or 36 bytes on a 64bit CPU. An entry is needed for each individual operation applied to the stack (such as rotate, scale, translate) so if most of your leaf node transformations only need one or two simple operations relative to their parent then a matrix stack will likely take less space than having a CoglMatrix for each node.

Even without any space saving though the ability to perform fast comparisons and avoid redundant arithmetic (especially sine and cosine calculations for rotations) can make using a matrix stack worthwhile.

## Functions

### cogl_matrix_stack_new ()

    CoglMatrixStack *
    cogl_matrix_stack_new (CoglContext *ctx);

Allocates a new CoglMatrixStack that can be used to build up transformations relating to objects in a scenegraph like hierarchy. (See the description of CoglMatrixStack and CoglMatrixEntry for more details of what a matrix stack is best suited for)

When a CoglMatrixStack is first allocated it is conceptually positioned at the root of your scenegraph hierarchy. As you traverse your scenegraph then you should call `cogl_matrix_stack_push()` whenever you move down a level and `cogl_matrix_stack_pop()` whenever you move back up a level towards the root.

Once you have allocated a CoglMatrixStack you can get a reference to the current transformation for the current position in the hierarchy by calling `cogl_matrix_stack_get_entry()`.

Once you have allocated a CoglMatrixStack you can apply operations such as rotate, scale and translate to modify the current transform for the current position in the hierarchy by calling `cogl_matrix_stack_rotate()`, `cogl_matrix_stack_scale()` and `cogl_matrix_stack_translate()`.

#### Parameters

ctx | A CoglContext |

#### Returns

A newly allocated CoglMatrixStack.

[transfer full]

### cogl_matrix_stack_push ()

    void
    cogl_matrix_stack_push (CoglMatrixStack *stack);

Saves the current transform and starts a new transform that derives from the current transform.

This is usually called while traversing a scenegraph whenever you traverse one level deeper. `cogl_matrix_stack_pop()` can then be called when going back up one layer to restore the previous transform of an ancestor.

#### Parameters

stack | A CoglMatrixStack |

### cogl_matrix_stack_pop ()

    void
    cogl_matrix_stack_pop (CoglMatrixStack *stack);

Restores the previous transform that was last saved by calling `cogl_matrix_stack_push()`.

This is usually called while traversing a scenegraph whenever you return up one level in the graph towards the root node.

#### Parameters

stack | A CoglMatrixStack |

### cogl_matrix_stack_load_identity ()

    void
    cogl_matrix_stack_load_identity (CoglMatrixStack *stack);

Resets the current matrix to the identity matrix.

#### Parameters

stack | A CoglMatrixStack |

### cogl_matrix_stack_scale ()

    void
    cogl_matrix_stack_scale (CoglMatrixStack *stack,
                             float x,
                             float y,
                             float z);

Multiplies the current matrix by one that scales the x, y and z axes by the given values.

#### Parameters

stack | A CoglMatrixStack |
x | Amount to scale along the x-axis |
y | Amount to scale along the y-axis |
z | Amount to scale along the z-axis |

### cogl_matrix_stack_translate ()

    void
    cogl_matrix_stack_translate (CoglMatrixStack *stack,
                                 float x,
                                 float y,
                                 float z);

Multiplies the current matrix by one that translates along all three axes according to the given values.

#### Parameters

stack | A CoglMatrixStack |
x | Distance to translate along the x-axis |
y | Distance to translate along the y-axis |
z | Distance to translate along the z-axis |

### cogl_matrix_stack_rotate ()

    void
    cogl_matrix_stack_rotate (CoglMatrixStack *stack,
                              float angle,
                              float x,
                              float y,
                              float z);

Multiplies the current matrix by one that rotates the around the axis-vector specified by `x` , `y` and `z` . The rotation follows the right-hand thumb rule so for example rotating by 10 degrees about the axis-vector (0, 0, 1) causes a small counter-clockwise rotation.

#### Parameters

stack | A CoglMatrixStack |
angle | Angle in degrees to rotate. |
x | X-component of vertex to rotate around. |
y | Y-component of vertex to rotate around. |
z | Z-component of vertex to rotate around. |

### cogl_matrix_stack_rotate_quaternion ()

    void
    cogl_matrix_stack_rotate_quaternion (CoglMatrixStack *stack,
                                         const CoglQuaternion *quaternion);

Multiplies the current matrix by one that rotates according to the rotation described by `quaternion` .

#### Parameters

stack | A CoglMatrixStack |
quaternion | A CoglQuaternion |

### cogl_matrix_stack_rotate_euler ()

    void
    cogl_matrix_stack_rotate_euler (CoglMatrixStack *stack,
                                    const CoglEuler *euler);

Multiplies the current matrix by one that rotates according to the rotation described by `euler` .

#### Parameters

stack | A CoglMatrixStack |
euler | A CoglEuler |

### cogl_matrix_stack_multiply ()

    void
    cogl_matrix_stack_multiply (CoglMatrixStack *stack,
                                const CoglMatrix *matrix);

Multiplies the current matrix by the given matrix.

#### Parameters

stack | A CoglMatrixStack |
matrix | the matrix to multiply with the current model-view |

### cogl_matrix_stack_frustum ()

    void
    cogl_matrix_stack_frustum (CoglMatrixStack *stack,
                               float left,
                               float right,
                               float bottom,
                               float top,
                               float z_near,
                               float z_far);

Replaces the current matrix with a perspective matrix for a given viewing frustum defined by 4 side clip planes that all cross through the origin and 2 near and far clip planes.

#### Parameters

stack | A CoglMatrixStack |
left | X position of the left clipping plane where it intersects the near clipping plane |
right | X position of the right clipping plane where it intersects the near clipping plane |
bottom | Y position of the bottom clipping plane where it intersects the near clipping plane |
top | Y position of the top clipping plane where it intersects the near clipping plane |
z_near | The distance to the near clipping plane (Must be positive) |
z_far | The distance to the far clipping plane (Must be positive) |

### cogl_matrix_stack_perspective ()

    void
    cogl_matrix_stack_perspective (CoglMatrixStack *stack,
                                   float fov_y,
                                   float aspect,
                                   float z_near,
                                   float z_far);

Replaces the current matrix with a perspective matrix based on the provided values.

You should be careful not to have too great a `z_far` / `z_near` ratio since that will reduce the effectiveness of depth testing since there wont be enough precision to identify the depth of objects near to each other.

#### Parameters

stack | A CoglMatrixStack |
fov_y | Vertical field of view angle in degrees. |
aspect | The (width over height) aspect ratio for display |
z_near | The distance to the near clipping plane (Must be positive, and must not be 0) |
z_far | The distance to the far clipping plane (Must be positive) |

### cogl_matrix_stack_orthographic ()

    void
    cogl_matrix_stack_orthographic (CoglMatrixStack *stack,
                                    float x_1,
                                    float y_1,
                                    float x_2,
                                    float y_2,
                                    float near,
                                    float far);

Replaces the current matrix with an orthographic projection matrix.

#### Parameters

stack | A CoglMatrixStack |
x_1 | The x coordinate for the first vertical clipping plane |
y_1 | The y coordinate for the first horizontal clipping plane |
x_2 | The x coordinate for the second vertical clipping plane |
y_2 | The y coordinate for the second horizontal clipping plane |
near | The distance to the near clipping plane (will be negative if the plane is behind the viewer) |
far | The distance to the far clipping plane (will be negative if the plane is behind the viewer) |

### cogl_matrix_stack_get_inverse ()

    CoglBool
    cogl_matrix_stack_get_inverse (CoglMatrixStack *stack,
                                   CoglMatrix *inverse);

Gets the inverse transform of the current matrix and uses it to initialize a new CoglMatrix.

#### Parameters

stack | A CoglMatrixStack |
inverse | The destination for a 4x4 inverse transformation matrix. | [out]

#### Returns

`TRUE` if the inverse was successfully calculated or `FALSE` for degenerate transformations that can't be inverted (in this case the `inverse` matrix will simply be initialized with the identity matrix)

### cogl_matrix_stack_get_entry ()

    CoglMatrixEntry *
    cogl_matrix_stack_get_entry (CoglMatrixStack *stack);

Gets a reference to the current transform represented by a CoglMatrixEntry pointer.

The transform represented by a CoglMatrixEntry is immutable.
CoglMatrixEntrys are reference counted using `cogl_matrix_entry_ref()` and `cogl_matrix_entry_unref()` and you should call `cogl_matrix_entry_unref()` when you are finished with and entry you get via `cogl_matrix_stack_get_entry()`.

#### Parameters

stack | A CoglMatrixStack |

#### Returns

A pointer to the CoglMatrixEntry representing the current matrix stack transform.

[transfer none]

### cogl_matrix_stack_get ()

    CoglMatrix *
    cogl_matrix_stack_get (CoglMatrixStack *stack,
                           CoglMatrix *matrix);

Resolves the current `stack` transform into a CoglMatrix by combining the operations that have been applied to build up the current transform.

There are two possible ways that this function may return its result depending on whether the stack is able to directly point to an internal CoglMatrix or whether the result needs to be composed of multiple operations.

If an internal matrix contains the required result then this function will directly return a pointer to that matrix, otherwise if the function returns `NULL` then `matrix` will be initialized to match the current transform of `stack` .

`matrix` will be left untouched if a direct pointer is returned.

#### Parameters

stack | A CoglMatrixStack |
matrix | The potential destination for the current matrix. | [out]

#### Returns

A direct pointer to the current transform or `NULL` and in that case `matrix` will be initialized with the value of the current transform.

### cogl_matrix_entry_get ()

    CoglMatrix *
    cogl_matrix_entry_get (CoglMatrixEntry *entry,
                           CoglMatrix *matrix);

Resolves the current `entry` transform into a CoglMatrix by combining the sequence of operations that have been applied to build up the current transform.

There are two possible ways that this function may return its result depending on whether it's possible to directly point to an internal CoglMatrix or whether the result needs to be composed of multiple operations.

If an internal matrix contains the required result then this function will directly return a pointer to that matrix, otherwise if the function returns `NULL` then `matrix` will be initialized to match the transform of `entry` .

`matrix` will be left untouched if a direct pointer is returned.

#### Parameters

entry | A CoglMatrixEntry |
matrix | The potential destination for the transform as a matrix. | [out]

#### Returns

A direct pointer to a CoglMatrix transform or `NULL` and in that case `matrix` will be initialized with the effective transform represented by `entry` .

### cogl_matrix_stack_set ()

    void
    cogl_matrix_stack_set (CoglMatrixStack *stack,
                           const CoglMatrix *matrix);

Replaces the current `stack` matrix value with the value of `matrix` . This effectively discards any other operations that were applied since the last time `cogl_matrix_stack_push()` was called or since the stack was initialized.

#### Parameters

stack | A CoglMatrixStack |
matrix | A CoglMatrix replace the current matrix value with |

### cogl_matrix_entry_calculate_translation ()

    CoglBool
    cogl_matrix_entry_calculate_translation
                                   (CoglMatrixEntry *entry0,
                                    CoglMatrixEntry *entry1,
                                    float *x,
                                    float *y,
                                    float *z);

Determines if the only difference between two transforms is a translation and if so returns what the `x` , `y` , and `z` components of the translation are.

If the difference between the two translations involves anything other than a translation then the function returns `FALSE`.

#### Parameters

entry0 | The first reference transform |
entry1 | A second reference transform |
x | The destination for the x-component of the translation. | [out]
y | The destination for the y-component of the translation. | [out]
z | The destination for the z-component of the translation. | [out]

#### Returns

`TRUE` if the only difference between the transform of `entry0` and the transform of `entry1` is a translation, otherwise `FALSE`.

### cogl_matrix_entry_is_identity ()

    CoglBool
    cogl_matrix_entry_is_identity (CoglMatrixEntry *entry);

Determines whether `entry` is known to represent an identity transform.

If this returns `TRUE` then the entry is definitely the identity matrix. If it returns `FALSE` it may or may not be the identity matrix but no expensive comparison is performed to verify it.

#### Parameters

entry | A CoglMatrixEntry |

#### Returns

`TRUE` if `entry` is definitely an identity transform, otherwise `FALSE`.

### cogl_matrix_entry_equal ()

    CoglBool
    cogl_matrix_entry_equal (CoglMatrixEntry *entry0,
                             CoglMatrixEntry *entry1);

Compares two arbitrary CoglMatrixEntry transforms for equality returning `TRUE` if they are equal or `FALSE` otherwise.

In many cases it is unnecessary to use this api and instead direct pointer comparisons of entries are good enough and much cheaper too.

#### Parameters

entry0 | The first CoglMatrixEntry to compare |
entry1 | A second CoglMatrixEntry to compare |

#### Returns

`TRUE` if `entry0` represents the same transform as `entry1` , otherwise `FALSE`.

### cogl_matrix_entry_ref ()

    CoglMatrixEntry *
    cogl_matrix_entry_ref (CoglMatrixEntry *entry);

Takes a reference on the given `entry` to ensure the `entry` stays alive and remains valid. When you are finished with the `entry` then you should call `cogl_matrix_entry_unref()`.

It is an error to pass an `entry` pointer to `cogl_object_ref()` and `cogl_object_unref()`

#### Parameters

entry | A CoglMatrixEntry |

### cogl_matrix_entry_unref ()

    void
    cogl_matrix_entry_unref (CoglMatrixEntry *entry);

Releases a reference on `entry` either taken by calling `cogl_matrix_entry_unref()` or to release the reference given when calling `cogl_matrix_stack_get_entry()`.

#### Parameters

entry | A CoglMatrixEntry |

## Types and Values

### CoglMatrixStack

    typedef struct _CoglMatrixStack CoglMatrixStack;

Tracks your current position within a hierarchy and lets you build up a graph of transformations as you traverse through a hierarchy such as a scenegraph.

A CoglMatrixStack always maintains a reference to a single transformation at any point in time, representing the transformation at the current position in the hierarchy. You can get a reference to the current transformation by calling `cogl_matrix_stack_get_entry()`.

When a CoglMatrixStack is first created with `cogl_matrix_stack_new()` then it is conceptually positioned at the root of your hierarchy and the current transformation simply represents an identity transformation.

As you traverse your object hierarchy (your scenegraph) then you should call `cogl_matrix_stack_push()` whenever you move down one level and call `cogl_matrix_stack_pop()` whenever you move back up one level towards the root.

At any time you can apply a set of operations, such as "rotate", "scale", "translate" on top of the current transformation of a CoglMatrixStack using functions such as `cogl_matrix_stack_rotate()`, `cogl_matrix_stack_scale()` and `cogl_matrix_stack_translate()`. These operations will derive a new current transformation and will never affect a transformation that you have referenced using `cogl_matrix_stack_get_entry()`.

Internally applying operations to a CoglMatrixStack builds up a graph of CoglMatrixEntry structures which each represent a single immutable transform.

### CoglMatrixEntry

    typedef struct _CoglMatrixEntry CoglMatrixEntry;

Represents a single immutable transformation that was retrieved from a CoglMatrixStack using `cogl_matrix_stack_get_entry()`.

Internally a CoglMatrixEntry represents a single matrix operation (such as "rotate", "scale", "translate") which is applied to the transform of a single parent entry.

Using the CoglMatrixStack api effectively builds up a graph of these immutable CoglMatrixEntry structures whereby operations that can be shared between multiple transformations will result in shared CoglMatrixEntry nodes in the graph.

When a CoglMatrixStack is first created it references one CoglMatrixEntry that represents a single "load identity" operation. This serves as the root entry and all operations that are then applied to the stack will extend the graph starting from this root "load identity" entry.

Given the typical usage model for a CoglMatrixStack and the way the entries are built up while traversing a scenegraph then in most cases where an application is interested in comparing two transformations for equality then it is enough to simply compare two CoglMatrixEntry pointers directly. Technically this can lead to false negatives that could be identified with a deeper comparison but often these false negatives are unlikely and don't matter anyway so this enables extremely cheap comparisons.

CoglMatrixEntrys are reference counted using `cogl_matrix_entry_ref()` and `cogl_matrix_entry_unref()` not with `cogl_object_ref()` and `cogl_object_unref()`.